// =====================================================================
/*!
//
//  \file TDataSegment.hh
//  \brief This file contains the TDataSegment class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TDataSegment.hh,v 1.8 2003/12/06 10:59:11 goiwai Exp $
//  $Name: CLDAQ-1-11-00 $
//  $Log: TDataSegment.hh,v $
//  Revision 1.8  2003/12/06 10:59:11  goiwai
//  Serialize(Tvoid*) -> Serialize(const Tvoid*)に変更しました.
//  Deserialize(const Tvoid*)を追加しました.
//  手抜きの実装なので,バッファオーバーフローの可能性があります.
//  Reallocate()とかするような仕組みが必要です.
//
//  Revision 1.7  2003/11/24 06:56:49  goiwai
//  Size()メンバ関数を追加しました.
//  抱えているDataElementの数を返します.
//
//  Revision 1.6  2003/11/04 12:03:05  goiwai
//  ==演算子と!=演算子を実装しました.具体的には
//  if ( record == "String" ) {
//    hoeghoge;
//  }
//  のような使い方が出来ます.単純に theID メンバとを比較して結果を返します.
//
//  Revision 1.5  2003/11/03 08:35:12  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.4  2003/10/06 16:42:19  goiwai
//  *** empty log message ***
//
//  Revision 1.3  2003/08/25 09:21:44  goiwai
//  operator[]( const Tstring& id ) を加えました.
//  segment[0] とか segment["tag"] とかすれば, TDataElement を得ることが出
//  来ます.
//  size()を越えた範囲にも,チェックしないでアクセスします.
//  マッチしなかった場合は落ちます.
//  同じ名前でタグされた DataElement がある場合,最初にマッチしたものが返っ
//  てきます.
//
//  Revision 1.2  2003/07/30 16:17:51  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef __TDATASEGMENT_HH
#define __TDATASEGMENT_HH

#include "Tglobals.h"
#include "TStreamableObject.hh"
#include "TDataElementList.hh"

class TOutputObjectStream;
class TOutputObjectFile;
class TOutputObjectSocket;
class TOutputObjectSharedMemory;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TDataSegment
// \brief This is the TDataSegment class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TDataSegment class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup DatarecordCategory
*/
class TDataSegment
  : public TStreamableObject, public TDataElementList
{

  public:
    TDataSegment( const Tstring& id = TunknownID );
    TDataSegment( const TDataSegment& right );
    ~TDataSegment();

  public:
    Tint GetRecordSize();
    Tint Record( TOutputObjectStream* output );
    Tvoid Clear();
    Tint Serialize( const Tvoid* buffer );
    Tint Deserialize( const Tvoid* buffer );
    Tint Size() const;

  public:
    const TDataSegment& operator=( const TDataSegment& right );
    Tbool operator==( const TDataSegment& right ) const;
    Tbool operator!=( const TDataSegment& right ) const;
    Tbool operator==( const Tstring& right ) const;
    Tbool operator!=( const Tstring& right ) const;
    const TDataElement& operator[]( Tint n ) const;
    TDataElement& operator[]( Tint n );
    const TDataElement& operator[]( const Tstring& id ) const;
    TDataElement& operator[]( const Tstring& id );
    friend Tostream& operator<<( Tostream& tos, const TDataSegment& right );

  public:
    Tbool FindDataElement( const Tstring& id, TDataElement& element ) const;
    Tint FindDataElement( const Tstring& id ) const;

  private:
    Tint record( TOutputObjectFile* ofile );
    Tint record( TOutputObjectSocket* osocket );
    Tint record( TOutputObjectSharedMemory* omemory );

};

inline Tint TDataSegment::Size() const
{
  return (Tint)size();
}

#endif
